import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.text.DecimalFormat;
/**
 * Write a description of class farmland here.
 * 
 * @Pan Weili from Taiwan LSSH 臺北市立麗山高級中學 資訊組潘威歷 
 * @version 201502060900
 */
public class farmland extends World
{
        private ArrayList<farmCell> sList=new ArrayList();;
    private int[][] oList=
    //紀錄每種圖形的開口方向，總共有11種情形
    {
        {1,0,0,1},  //上右開
        {1,1,0,0},  //上下開
        {0,1,0,1},  //下右開
        {1,1,0,1},  //上下右開
        {1,0,1,0},  //上左開
        {0,0,1,1},  //左右開
        {1,0,1,1},  //上左右開
        {0,1,1,0},  //下左開
        {1,1,1,0},  //上下左開
        {0,1,1,1},  //下左右開
        {1,1,1,1},  //上下左右都開
    };
    private int count=0;  //紀錄目前擺了多少方格
    private int connectCount=-1; //最後紀錄連通了多少個方格，但是最初的連通點不能算，所以以-1開始
    private farmCell startCell=new farmCell(11,0,1,0,0);  //最初的連通點
    /**
     * Constructor for objects of class farmland.
     * 
     */
    public farmland()
    {    
        super(13, 10, 48);
        setPaintOrder(setBox.class,chooseBox.class,farmCell.class);
        addObject(new chooseBox(),8,2);
        addObject(new setBox(),2,4);
        addObject(startCell,8,1);
        initStack();
        showStack();
    }
    
    /**
     * 將Stack初始化
     */
    private void initStack()
    {
        int no=0;
        for (int i=0;i<40;i++)
        {
            no=Greenfoot.getRandomNumber(11);
            sList.add(new farmCell(no,oList[no][0],oList[no][1],oList[no][2],oList[no][3]));
        }
    }

    /**
     * 秀出Stack
     */
    private void showStack()
    {
        for(int i=4;i>0;i--)
        {
            addObject(sList.get(4-i),2,i);
        }
    }
    
    /**
     * 隱藏Stack
     */
    private void hideStack()
    {
        for (int i=0;i<4;i++)
        {
            removeObject(sList.get(i));
        } 
    }

    /**
     * 從Stack中取出最前面的元素
     */
    public farmCell popStack()
    {
        hideStack();
        farmCell f = (farmCell)sList.get(0);
        sList.remove(0);
        showStack();
        return f;
    }
    
    /**
     * 每放下一塊連通點，計數器就加1
     */
    public void addCount()
    {
        count++;
    }

    /**
     * 每連到一塊連通點時才加1
     */
    public void addConnectCount()
    {
        connectCount++;
    }
    
    /**
     * 隨時監測是否已完成所有區塊
     */
    private void checkCount()
    {
        if (count==36)
        {
            startCell.setImage("wspr"+startCell.getValue()[0]+".png");
            startCell.checkCell();
            float percent = (float)connectCount/count;
            DecimalFormat df=new DecimalFormat("0.00%");
            String s=df.format(percent);   
            addObject(new Label(s,20),10,8);
            addObject(new completeness(percent),6,8);
            Greenfoot.stop();
        }
    }
    
    public void act() 
    {
        checkCount();
    }
}
